
{*******************************************************}
{                                                       }
{       RichView                                        }
{       Demo: using EDSSpell (TRVSpellDlg) component    }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{       EDSSpell : Copyright (c) OneDomain, Inc         }
{       http://www.onedomain.com                        }
{                                                       }
{*******************************************************}

{ Known problem: I do not know how to detect when word is added in "Ignore All"
  list or in the dictionary (normally, RichViewEdit1.LiveSpellingValidateWord
  should be called in these cases). Please contact EDSSpell developers for the
  info. (ST) }


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, RVEdit, StdCtrls, RVWordEnum,
  Menus, EDSSpell, RVEDSSpell;

type
  TForm1 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button1: TButton;
    PopupMenu1: TPopupMenu;
    RVSpellDlg1: TRVSpellDlg;
    procedure FormCreate(Sender: TObject);
    procedure RichViewEdit1SpellingCheck(Sender: TCustomRichView;
      const AWord: String; StyleNo: Integer; var Misspelled: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
  private
    { Private declarations }
    procedure PopupMenuItemClick(Sender: TObject);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.AddNL('Speling contest - a kontest in wich you are elimineited if you fale to spel a vord corectly.', 0,0);
  RichViewEdit1.Format;
  RVSpellDlg1.OpenDictionary; // <-- important!  
  RichViewEdit1.StartLiveSpelling;
  PopupMenu1.AutoHotkeys := maManual;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  RVSpellDlg1.Check(RichViewEdit1, rvesFromStart);
end;

procedure TForm1.RichViewEdit1SpellingCheck(Sender: TCustomRichView;
  const AWord: String; StyleNo: Integer; var Misspelled: Boolean);
begin
  Misspelled := RVSpellDlg1.IsBadWord(AWord);
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
var wrd: String;
    stl, i: Integer;
    sl: TStringList;
    mi: TMenuItem;
begin
  while PopupMenu1.Items.Count>0 do
    PopupMenu1.Items[0].Free;
  if RichViewEdit1.GetCurrentMisspelling(True, wrd, stl) then begin
    sl := RVSpellDlg1.SuggestWords(wrd, 8);
    if sl=nil then
      exit;
    try
      for i := 0 to sl.Count-1 do begin
        mi := TMenuItem.Create(PopupMenu1);
        mi.Caption := sl[i];
        mi.OnClick := PopupMenuItemClick;
        PopupMenu1.Items.Add(mi);
      end;
      if sl.Count=0 then begin
        mi := TMenuItem.Create(PopupMenu1);
        mi.Caption := '(no suggestions)';
        mi.Enabled := False;
        PopupMenu1.Items.Add(mi);
      end;
    finally
      sl.Free;
    end;
  end;
end;

procedure TForm1.PopupMenuItemClick(Sender: TObject);
begin
  RichViewEdit1.InsertText((Sender as TMenuItem).Caption);
end;

end.
