
{*******************************************************}
{                                                       }
{       RichView                                        }
{       Demo: using EDSSpell (TRVSpellDlg) component    }
{       with RichViewActions                            }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{       EDSSpell : Copyright (c) OneDomain, Inc         }
{       http://www.onedomain.com                        }
{                                                       }
{*******************************************************}

{ Known problem: I do not know how to detect when word is added in "Ignore All"
  list or in the dictionary (normally, RichViewEdit1.LiveSpellingValidateWord
  should be called in these cases). Please contact EDSSpell developers for the
  info. (ST) }


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, RVEdit, StdCtrls, RVWordEnum,
  Menus, EDSSpell, RVEDSSpell, RichViewActions, ActnList;

type
  TForm1 = class(TForm)
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    Button1: TButton;
    RVSpellDlg1: TRVSpellDlg;
    RVAPopupMenu1: TRVAPopupMenu;
    ActionList1: TActionList;
    procedure FormCreate(Sender: TObject);
    procedure RichViewEdit1SpellingCheck(Sender: TCustomRichView;
      const AWord: String; StyleNo: Integer; var Misspelled: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure RVAPopupMenu1LiveSpellGetSuggestions(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer;
      Suggestions: TStrings);
    procedure RVAPopupMenu1LiveSpellAdd(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
    procedure RVAPopupMenu1LiveSpellIgnoreAll(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.AddNL('Speling contest - a kontest in wich you are elimineited if you fale to spel a vord corectly.', 0,0);
  RichViewEdit1.Format;
  RVSpellDlg1.OpenDictionary; // <-- important!  
  RichViewEdit1.StartLiveSpelling;
  RVA_LocalizeForm(Self); // assigning captions to "Ignore All" and "Add" menu items
end;
{ Starting a traditional (with dialog) spelling }
procedure TForm1.Button1Click(Sender: TObject);
begin
  RVSpellDlg1.Check(RichViewEdit1, rvesFromStart);
end;
{ Live spelling event }
procedure TForm1.RichViewEdit1SpellingCheck(Sender: TCustomRichView;
  const AWord: String; StyleNo: Integer; var Misspelled: Boolean);
begin
  Misspelled := RVSpellDlg1.IsBadWord(AWord);
end;
{ List of suggestions }
procedure TForm1.RVAPopupMenu1LiveSpellGetSuggestions(
  Sender: TRVAPopupMenu; Edit: TCustomRichViewEdit; const Word: String;
  StyleNo: Integer; Suggestions: TStrings);
var sl: TStringList;
begin
  sl := RVSpellDlg1.SuggestWords(Word, 8);
  try
    Suggestions.Assign(sl);
  finally
    sl.Free;
  end;
end;
{ Add to dictionary }
procedure TForm1.RVAPopupMenu1LiveSpellAdd(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
begin
  RVSpellDlg1.AddWord(Word);
  // RichViewEdit1.LiveSpellingValidateWord is called by the menu
end;
{ Add to ignore list }
procedure TForm1.RVAPopupMenu1LiveSpellIgnoreAll(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
begin
  RVSpellDlg1.SkipList.Add(Word);
  // RichViewEdit1.LiveSpellingValidateWord is called by the menu  
end;

end.
