unit Unit1;

interface

{$I RV_Defs.inc}

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, RVStyle, StdCtrls, RVScroll, RichView, RVEdit, RVWordEnum,
  RVHunSpell, RVUni, RVTypes, ActnList, RichViewActions, ExtCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    RichViewEdit1: TRichViewEdit;
    Button1: TButton;
    RVStyle1: TRVStyle;
    RVHunSpell1: TRVHunSpell;
    ListBox1: TListBox;
    RVAPopupMenu1: TRVAPopupMenu;
    ActionList1: TActionList;
    RadioGroup1: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure RichViewEdit1SpellingCheck(Sender: TCustomRichView;
      const AWord: string; StyleNo: Integer; var Misspelled: Boolean);
    procedure RVHunSpell1SpellFormAction(Sender: TRVHunSpell; const AWord,
      AReplaceTo: TRVUnicodeString; Action: TRVHunSpellFormAction);
    procedure RVAPopupMenu1LiveSpellGetSuggestions(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: string; StyleNo: Integer;
      Suggestions: TStrings);
    procedure RVAPopupMenu1LiveSpellIgnoreAll(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: string; StyleNo: Integer);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RVAPopupMenu1LiveSpellAdd(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
  private
    { Private declarations }
    function GetUnicode(const s: String; StyleNo: Integer): TRVUnicodeString;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}


procedure TForm1.FormCreate(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.AddNLTag(
    'Speling contest - a kontest in wich you are elimineited if you fale to spel a vord corectly.',
    0, 0, 0);
  RichViewEdit1.Format;

  // This demo assumes that dictionaries are in the application directory
  RVHunSpell1.Dictionaries.Clear;
  RVHunSpell1.LoadAllDictionaries;
  ListBox1.Items.Assign(RVHunSpell1.Dictionaries);

  RichViewEdit1.StartLiveSpelling;
end;
{ Converting s to Unicode }
function TForm1.GetUnicode(const s: String; StyleNo: Integer): TRVUnicodeString;
begin
  {$IFNDEF RICHVIEWDEF2009}
  // Delphi 4-2007: converting s to Unicode basing on the text style's Charset
  Result := RVU_RawUnicodeToWideString(RVU_AnsiToUnicode(
    RichViewEdit1.RVData.GetStyleCodePage(StyleNo), s));
  {$ELSE}
  // Delphi 2009+: s is already Unicode
  Result := s;
  {$ENDIF}
end;
{ Starting spelling }
procedure TForm1.Button1Click(Sender: TObject);
begin
  RVHunSpell1.Check(RichViewEdit1, rvesFromStart);
end;
{ Live spelling event }
procedure TForm1.RichViewEdit1SpellingCheck(Sender: TCustomRichView;
  const AWord: string; StyleNo: Integer; var Misspelled: Boolean);
begin
  Misspelled := not RVHunSpell1.Spell(GetUnicode(AWord, StyleNo));
end;
{ List of suggestions for menu }
procedure TForm1.RVAPopupMenu1LiveSpellGetSuggestions(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: string; StyleNo: Integer;
  Suggestions: TStrings);
begin
  RVHunSpell1.Suggest(GetUnicode(Word, StyleNo), Suggestions);
end;
{ Add to ignore list }
procedure TForm1.RVAPopupMenu1LiveSpellIgnoreAll(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: string; StyleNo: Integer);
begin
  RichViewEdit1.LiveSpellingValidateWord(Word);
  RVHunSpell1.AddToIgnoreList(GetUnicode(Word, StyleNo));
end;
{ Add to custom dictionary }
procedure TForm1.RVAPopupMenu1LiveSpellAdd(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
begin
  RichViewEdit1.LiveSpellingValidateWord(Word);
  RVHunSpell1.AddToDictionary(GetUnicode(Word, StyleNo));
end;
{ Called when button in the spelling dialog is clicked }
procedure TForm1.RVHunSpell1SpellFormAction(Sender: TRVHunSpell; const AWord,
  AReplaceTo: TRVUnicodeString; Action: TRVHunSpellFormAction);
begin
  if Action in [rvhsIgnoreAll, rvhsAdd] then
    RichViewEdit1.LiveSpellingValidateWord(AWord);
end;
{ Changing dialog style }
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  RVHunSpell1.SpellFormStyle := TRVHunSpellFormStyle(RadioGroup1.ItemIndex);
end;



end.
