
{*******************************************************}
{                                                       }
{       RichView                                        }
{       Demo: using LS Speller component                }
{       with RichViewActions                            }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{       LS Speller : Copyright (c) Luzius Schneider     }
{       http://www.luziusschneider.com/SpellerHome.htm  }
{                                                       }
{*******************************************************}


unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVStyle, RVScroll, RichView, RVEdit, StdCtrls, RVWordEnum,
  SpellLanguageComboBox, Spellers, RVLSSpell, Menus, RichViewActions,
  ActnList, ExtCtrls;

type
  TForm1 = class(TForm)
    SpellChecker1: TSpellChecker;
    SpellLanguageComboBox1: TSpellLanguageComboBox;
    RichViewEdit1: TRichViewEdit;
    RVStyle1: TRVStyle;
    RVLSSpell1: TRVLSSpell;
    Button1: TButton;
    RVAPopupMenu1: TRVAPopupMenu;
    ActionList1: TActionList;
    RadioGroup1: TRadioGroup;
    procedure FormCreate(Sender: TObject);
    procedure RichViewEdit1SpellingCheck(Sender: TCustomRichView;
      const AWord: String; StyleNo: Integer; var Misspelled: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure RVLSSpell1SpellFormAction(Sender: TRVLSSpell; const AWord,
      AReplaceTo: String; Action: TRVLSSpellFormAction);
    procedure SpellLanguageComboBox1Click(Sender: TObject);
    procedure RVAPopupMenu1LiveSpellGetSuggestions(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer;
      Suggestions: TStrings);
    procedure RVAPopupMenu1LiveSpellIgnoreAll(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
    procedure RVAPopupMenu1LiveSpellAdd(Sender: TRVAPopupMenu;
      Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  RichViewEdit1.Clear;
  RichViewEdit1.AddNLTag(
    'Speling contest - a kontest in wich you are elimineited if you fale to spel a vord corectly.',
    0,0, 0);
  RichViewEdit1.Format;
  RichViewEdit1.StartLiveSpelling;
end;
{ Starting a traditional (with dialog) spelling }
procedure TForm1.Button1Click(Sender: TObject);
begin
  RVLSSpell1.Check(RichViewEdit1, rvesFromStart);
end;
{ Live spelling event }
procedure TForm1.RichViewEdit1SpellingCheck(Sender: TCustomRichView;
  const AWord: String; StyleNo: Integer; var Misspelled: Boolean);
begin
  Misspelled := RVLSSpell1.IsMisspelled(AWord, Sender.Style.TextStyles[StyleNo]);
end;
{ Called when button in the spelling dialog is clicked }
procedure TForm1.RVLSSpell1SpellFormAction(Sender: TRVLSSpell; const AWord,
  AReplaceTo: String; Action: TRVLSSpellFormAction);
begin
  if Action in [rvlssIgnoreAll, rvlssChangeAll] then
    RichViewEdit1.LiveSpellingValidateWord(AWord);
end;
{ Choosing another dictionary }
procedure TForm1.SpellLanguageComboBox1Click(Sender: TObject);
begin
  RichViewEdit1.StartLiveSpelling;
end;
{ List of suggestions for menu }
procedure TForm1.RVAPopupMenu1LiveSpellGetSuggestions(
  Sender: TRVAPopupMenu; Edit: TCustomRichViewEdit; const Word: String;
  StyleNo: Integer; Suggestions: TStrings);
begin
  RVLSSpell1.SuggestWords(Word, RVStyle1.TextStyles[StyleNo], Suggestions);
end;
{ Add to ignore list }
procedure TForm1.RVAPopupMenu1LiveSpellIgnoreAll(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
begin
  RVLSSpell1.AddToIgnoreList(Word, RVStyle1.TextStyles[StyleNo]);
  // RichViewEdit1.LiveSpellingValidateWord is called by the menu
end;
{ Add to dictionary }
procedure TForm1.RVAPopupMenu1LiveSpellAdd(Sender: TRVAPopupMenu;
  Edit: TCustomRichViewEdit; const Word: String; StyleNo: Integer);
begin
  RVLSSpell1.SpellChecker.AddWord(Word,
    RVLSSpell1.GetCurLanguage(RVStyle1.TextStyles[StyleNo]));
  // RichViewEdit1.LiveSpellingValidateWord is called by the menu
end;
{ Changing spelling dialog style }
procedure TForm1.RadioGroup1Click(Sender: TObject);
begin
  RVLSSpell1.SpellFormStyle := TRVLSSpellFormStyle(RadioGroup1.ItemIndex);
end;

end.