{*******************************************************}
{                                                       }
{       RichView                                        }
{       Basic form for spell checking                   }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

{
  This form is not used directly. This is a parent class for:
  - TfrmRVSpell (RVSpellFrm.pas)
  - frmRVSpellWord (RVSpellWordFrm.pas)
}

unit RVCustomSpellFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Forms,
  Controls, StdCtrls;

type
  TfrmRVCustomSpell = class(TForm)
    lblTxt: TLabel;
    lblCmb: TLabel;
    btnIgnore: TButton;
    btnIgnoreAll: TButton;
    btnChange: TButton;
    btnChangeAll: TButton;
    btnCancel: TButton;
    btnAdd: TButton;
    procedure FormCreate(Sender: TObject);
  private
    procedure SetModalResults;
    { Private declarations }
  public
    { Public declarations }
    function IsReplacingItemText: Boolean; dynamic;
    function GetStringsForSuggestions: TStrings; dynamic;
    function GetCorrectedText: String; dynamic;
  end;

implementation

{$R *.dfm}

{============================ TfrmRVCustomSpell ===============================}
function TfrmRVCustomSpell.GetStringsForSuggestions: TStrings;
begin
  Result := nil;
end;
{------------------------------------------------------------------------------}
function TfrmRVCustomSpell.GetCorrectedText: String;
begin
  Result := '';
end;
{------------------------------------------------------------------------------}
function TfrmRVCustomSpell.IsReplacingItemText: Boolean;
begin
  Result := False;
end;
{------------------------------------------------------------------------------}
procedure TfrmRVCustomSpell.SetModalResults;
begin
  btnIgnore.ModalResult := mrNo;
  btnIgnoreAll.ModalResult := mrNoToAll;
  btnChange.ModalResult := mrYes;
  btnChangeAll.ModalResult := mrYesToAll;
  btnAdd.ModalResult := mrOk;
  btnCancel.ModalResult := mrCancel;
end;
{------------------------------------------------------------------------------}
procedure TfrmRVCustomSpell.FormCreate(Sender: TObject);
begin
  SetModalResults;
end;

end.
