
{*******************************************************}
{                                                       }
{       Win <-> Koi8-R translation is based on work of  }
{       Albert A. Mavrin <amavr@yahoo.com>              }
{       (since 2003-06-06,                              }
{        Koi8-R was changed to Koi8-U )                 }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}


unit RVKoi8;

interface
uses RVTypes;

procedure ConvertKoi8ToWin(var s: TRVRawByteString);
procedure ConvertWinToKoi8(var s: TRVRawByteString);

implementation

const
  WinToKoi8: array[TRVAnsiChar] of TRVAnsiChar =
    (#$00,#$01,#$02,#$03,#$04,#$05,#$06,#$07,#$08,#$09,#$0A,#$0B,#$0C,#$0D,#$0E,#$0F,
     #$10,#$11,#$12,#$13,#$14,#$15,#$16,#$17,#$18,#$19,#$1A,#$1B,#$1C,#$1D,#$1E,#$1F,
     #$20,#$21,#$22,#$23,#$24,#$25,#$26,#$27,#$28,#$29,#$2A,#$2B,#$2C,#$2D,#$2E,#$2F,
     #$30,#$31,#$32,#$33,#$34,#$35,#$36,#$37,#$38,#$39,#$3A,#$3B,#$3C,#$3D,#$3E,#$3F,
     #$40,#$41,#$42,#$43,#$44,#$45,#$46,#$47,#$48,#$49,#$4A,#$4B,#$4C,#$4D,#$4E,#$4F,
     #$50,#$51,#$52,#$53,#$54,#$55,#$56,#$57,#$58,#$59,#$5A,#$5B,#$5C,#$5D,#$5E,#$5F,
     #$60,#$61,#$62,#$63,#$64,#$65,#$66,#$67,#$68,#$69,#$6A,#$6B,#$6C,#$6D,#$6E,#$6F,
     #$70,#$71,#$72,#$73,#$74,#$75,#$76,#$77,#$78,#$79,#$7A,#$7B,#$7C,#$7D,#$7E,#$7F,

     #$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,
     #$94,#$94,#$94,#$94,#$94,#$95,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,#$94,
     #$9A,#$94,#$94,#$94,#$94,#$BD,#$94,#$94,#$B3,#$BF,#$B4,#$94,#$94,#$94,#$94,#$B7,
     #$9C,#$94,#$B6,#$A6,#$AD,#$94,#$94,#$9E,#$A3,#$94,#$A4,#$94,#$94,#$94,#$94,#$A7,
     #$E1,#$E2,#$F7,#$E7,#$E4,#$E5,#$F6,#$FA,#$E9,#$EA,#$EB,#$EC,#$ED,#$EE,#$EF,#$F0,
     #$F2,#$F3,#$F4,#$F5,#$E6,#$E8,#$E3,#$FE,#$FB,#$FD,#$FF,#$F9,#$F8,#$FC,#$E0,#$F1,
     #$C1,#$C2,#$D7,#$C7,#$C4,#$C5,#$D6,#$DA,#$C9,#$CA,#$CB,#$CC,#$CD,#$CE,#$CF,#$D0,
     #$D2,#$D3,#$D4,#$D5,#$C6,#$C8,#$C3,#$DE,#$DB,#$DD,#$DF,#$D9,#$D8,#$DC,#$C0,#$D1);

  Koi8ToWin: array[TRVAnsiChar] of TRVAnsiChar =
    (#$00,#$01,#$02,#$03,#$04,#$05,#$06,#$07,#$08,#$09,#$0A,#$0B,#$0C,#$0D,#$0E,#$0F,
     #$10,#$11,#$12,#$13,#$14,#$15,#$16,#$17,#$18,#$19,#$1A,#$1B,#$1C,#$1D,#$1E,#$1F,
     #$20,#$21,#$22,#$23,#$24,#$25,#$26,#$27,#$28,#$29,#$2A,#$2B,#$2C,#$2D,#$2E,#$2F,
     #$30,#$31,#$32,#$33,#$34,#$35,#$36,#$37,#$38,#$39,#$3A,#$3B,#$3C,#$3D,#$3E,#$3F,
     #$40,#$41,#$42,#$43,#$44,#$45,#$46,#$47,#$48,#$49,#$4A,#$4B,#$4C,#$4D,#$4E,#$4F,
     #$50,#$51,#$52,#$53,#$54,#$55,#$56,#$57,#$58,#$59,#$5A,#$5B,#$5C,#$5D,#$5E,#$5F,
     #$60,#$61,#$62,#$63,#$64,#$65,#$66,#$67,#$68,#$69,#$6A,#$6B,#$6C,#$6D,#$6E,#$6F,
     #$70,#$71,#$72,#$73,#$74,#$75,#$76,#$77,#$78,#$79,#$7A,#$7B,#$7C,#$7D,#$7E,#$7F,

     #$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,#$3F,
     #$3F,#$3F,#$3F,#$3F,#$3F,#$95,#$3F,#$3F,#$3F,#$3F,#$A0,#$3F,#$B0,#$3F,#$B7,#$3F,
     #$3F,#$3F,#$3F,#$B8,#$BA,#$3F,#$B3,#$BF,#$3F,#$3F,#$3F,#$3F,#$3F,#$B4,#$3F,#$3F,
     #$3F,#$3F,#$3F,#$A8,#$AA,#$3F,#$B2,#$AF,#$3F,#$3F,#$3F,#$3F,#$3F,#$A5,#$3F,#$A9,
     #$FE,#$E0,#$E1,#$F6,#$E4,#$E5,#$F4,#$E3,#$F5,#$E8,#$E9,#$EA,#$EB,#$EC,#$ED,#$EE,
     #$EF,#$FF,#$F0,#$F1,#$F2,#$F3,#$E6,#$E2,#$FC,#$FB,#$E7,#$F8,#$FD,#$F9,#$F7,#$FA,
     #$DE,#$C0,#$C1,#$D6,#$C4,#$C5,#$D4,#$C3,#$D5,#$C8,#$C9,#$CA,#$CB,#$CC,#$CD,#$CE,
     #$CF,#$DF,#$D0,#$D1,#$D2,#$D3,#$C6,#$C2,#$DC,#$DB,#$C7,#$D8,#$DD,#$D9,#$D7,#$DA);

procedure ConvertWinToKoi8(var s: TRVRawByteString);
var i: Integer;
begin
  SetLength(s, Length(s));
  for i := 1 to Length(s) do
    s[i] := WinToKoi8[s[i]];
end;

procedure ConvertKoi8ToWin(var s: TRVRawByteString);
var i: Integer;
begin
  SetLength(s, Length(s));
  for i := 1 to Length(s) do
    s[i] := Koi8ToWin[s[i]];
end;

{
procedure ConvertWinToKoi8(var s: TRVRawByteString);
var
  Table: Pointer;
  Buf: PRVAnsiChar;
  Len: Integer;
begin
  SetLength(s, Length(s));
  Buf := PRVAnsiChar(s);
  Table := @WinToKoi8;
  Len := Length(s);
  if Len=0 then
    exit;
  asm
     mov   ebx, Table
     mov   ecx, Len
     mov   edx, Buf
@1:  mov   al,  [edx]
     xlat
     mov   [edx], al
     inc   edx
     dec   ecx
     jnz @1
  end;
end;

procedure ConvertKoi8ToWin(var s: TRVRawByteString);
var
  Table: Pointer;
  Buf: PRVAnsiChar;
  Len: Integer;
begin
  SetLength(s, Length(s));
  Buf := PRVAnsiChar(s);
  Table := @Koi8ToWin;
  Len := Length(s);
  if Len=0 then
    exit;
  asm
     mov   ebx, Table
     mov   ecx, Len
     mov   edx, Buf
@1:  mov   al,  [edx]
     xlat
     mov   [edx], al
     inc   edx
     dec   ecx
     jnz @1
  end;
end;
}

end.
