{*******************************************************}
{                                                       }
{       RichView                                        }
{       Working with spelling dialogs                   }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

unit RVSpellFormUtils;

interface
uses
  Classes, Forms,
  RVStyle,
  RVCustomSpellFrm, RVSpellFrm, RVSpellWordFrm;

type
  TRVSpellFormStyle = (rvspellfrmClassic, rvspellfrmMSWord);

procedure CreateSpellForm(SpellFormStyle: TRVSpellFormStyle;
  var frm: TfrmRVCustomSpell);
procedure BeforeShowSpellForm(const AWord, AText: String;
  StartOffs, EndOffs: Integer; frm: TfrmRVCustomSpell; TextStyle: TFontInfo);

implementation

{------------------------------------------------------------------------------}
procedure CreateSpellForm(SpellFormStyle: TRVSpellFormStyle;
  var frm: TfrmRVCustomSpell);
begin
  if frm<>nil then
    exit;
  case SpellFormStyle of
    rvspellfrmMSWord:
      begin
        frm := TfrmRVSpellWord.Create(Application);
        TfrmRVSpellWord(frm).lst.Items.Clear;
      end;
    else
      begin
        frm := TfrmRVSpell.Create(Application);
        TfrmRVSpell(frm).cmb.Items.Clear;
        TfrmRVSpell(frm).cmb.Text := '';
      end;
  end;
end;
{------------------------------------------------------------------------------}
procedure BeforeShowSpellForm(const AWord, AText: String;
  StartOffs, EndOffs: Integer; frm: TfrmRVCustomSpell; TextStyle: TFontInfo);
begin
  if frm is TfrmRVSpellWord then begin
    if TfrmRVSpellWord(frm).lst.Items.Count>0 then
      TfrmRVSpellWord(frm).lst.ItemIndex := 0;
    TfrmRVSpellWord(frm).Init(AText, StartOffs, EndOffs-StartOffs,
      TextStyle);
    TfrmRVSpellWord(frm).lst.Font.Charset := TextStyle.Charset;
    end
  else if frm is TfrmRVSpell then begin
    if TfrmRVSpell(frm).cmb.Items.Count>0 then
      TfrmRVSpell(frm).cmb.ItemIndex := 0;
    TfrmRVSpell(frm).cmb.Font.Charset := TextStyle.Charset;
    TfrmRVSpell(frm).txtWrongWord.Font.Charset := TextStyle.Charset;    
    TfrmRVSpell(frm).txtWrongWord.Text := AWord;
  end;
end;

end.
