{*******************************************************}
{                                                       }
{       RichView                                        }
{       Classic form for spell checking                 }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

unit RVSpellFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, RVCustomSpellFrm, StdCtrls;

type
  TfrmRVSpell = class(TfrmRVCustomSpell)
    cmb: TComboBox;
    txtWrongWord: TEdit;
    procedure cmbKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbDblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetStringsForSuggestions: TStrings; override;
    function GetCorrectedText: String; override;
  end;

implementation

{$R *.dfm}

procedure TfrmRVSpell.cmbKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key=VK_ESCAPE then
    ModalResult := mrCancel;
end;
{------------------------------------------------------------------------------}
procedure TfrmRVSpell.cmbDblClick(Sender: TObject);
begin
 if cmb.ItemIndex>=0 then
    ModalResult := mrYes;
end;
{------------------------------------------------------------------------------}
function TfrmRVSpell.GetStringsForSuggestions: TStrings;
begin
  Result := cmb.Items;
end;
{------------------------------------------------------------------------------}
function TfrmRVSpell.GetCorrectedText: String;
begin
  Result := cmb.Text;
end;

procedure TfrmRVSpell.FormActivate(Sender: TObject);
begin
  cmb.SetFocus;
end;

end.
