{*******************************************************}
{                                                       }
{       RichView                                        }
{       Working with spelling dialogs                   }
{       (TNT controls version)                          }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

unit RVTntSpellFormUtils;

interface
uses
  Classes, Forms,
  RVStyle,
  RVTntCustomSpellFrm, RVTntSpellFrm, RVTntSpellWordFrm;

type
  TRVSpellFormStyle = (rvspellfrmClassic, rvspellfrmMSWord);

procedure CreateSpellForm(SpellFormStyle: TRVSpellFormStyle;
  var frm: TfrmRVTntCustomSpell);
procedure BeforeShowSpellForm(const AWord, AText: WideString;
  StartOffs, EndOffs: Integer; frm: TfrmRVTntCustomSpell; TextStyle: TFontInfo);

implementation

{------------------------------------------------------------------------------}
procedure CreateSpellForm(SpellFormStyle: TRVSpellFormStyle;
  var frm: TfrmRVTntCustomSpell);
begin
  if frm<>nil then
    exit;
  case SpellFormStyle of
    rvspellfrmMSWord:
      begin
        frm := TfrmRVTntSpellWord.Create(Application);
        TfrmRVTntSpellWord(frm).lst.Items.Clear;
      end;
    else
      begin
        frm := TfrmRVTntSpell.Create(Application);
        TfrmRVTntSpell(frm).cmb.Items.Clear;
        TfrmRVTntSpell(frm).cmb.Text := '';
      end;
  end;
end;
{------------------------------------------------------------------------------}
procedure BeforeShowSpellForm(const AWord, AText: WideString;
  StartOffs, EndOffs: Integer; frm: TfrmRVTntCustomSpell; TextStyle: TFontInfo);
begin
  if frm is TfrmRVTntSpellWord then begin
    if TfrmRVTntSpellWord(frm).lst.Items.Count>0 then
      TfrmRVTntSpellWord(frm).lst.ItemIndex := 0;
    TfrmRVTntSpellWord(frm).Init(AText, StartOffs, EndOffs-StartOffs,
      TextStyle);
    TfrmRVTntSpellWord(frm).lst.Font.Charset := TextStyle.Charset;
    end
  else if frm is TfrmRVTntSpell then begin
    if TfrmRVTntSpell(frm).cmb.Items.Count>0 then
      TfrmRVTntSpell(frm).cmb.ItemIndex := 0;
    TfrmRVTntSpell(frm).cmb.Font.Charset := TextStyle.Charset;
    TfrmRVTntSpell(frm).txtWrongWord.Font.Charset := TextStyle.Charset;
    TfrmRVTntSpell(frm).txtWrongWord.Text := AWord;
  end;
end;

end.
