{*******************************************************}
{                                                       }
{       TRichView                                       }
{       Classic form for spell checking                 }
{       (TNT-controls version)                          }
{                                                       }
{       RichView: Copyright (c) Sergey Tkachenko        }
{       svt@trichview.com                               }
{       http://www.trichview.com                        }
{                                                       }
{*******************************************************}

unit RVTntSpellFrm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, RVTntCustomSpellFrm, TntStdCtrls, TntClasses;

type
  TfrmRVTntSpell = class(TfrmRVTntCustomSpell)
    cmb: TTntComboBox;
    txtWrongWord: TTntEdit;
    procedure cmbKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure cmbDblClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    function GetStringsForSuggestions: TTntStrings; override;
    function GetCorrectedText: WideString; override;
  end;

implementation

{$R *.dfm}

procedure TfrmRVTntSpell.cmbKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 if Key=VK_ESCAPE then
    ModalResult := mrCancel;
end;
{------------------------------------------------------------------------------}
procedure TfrmRVTntSpell.cmbDblClick(Sender: TObject);
begin
 if cmb.ItemIndex>=0 then
    ModalResult := mrYes;
end;
{------------------------------------------------------------------------------}
function TfrmRVTntSpell.GetStringsForSuggestions: TTntStrings;
begin
  Result := cmb.Items;
end;
{------------------------------------------------------------------------------}
function TfrmRVTntSpell.GetCorrectedText: WideString;
begin
  Result := cmb.Text;
end;

procedure TfrmRVTntSpell.FormActivate(Sender: TObject);
begin
  cmb.SetFocus;
end;

end.
